#!/bin/sh

STAGED_FILES=$(git diff --cached --name-only --diff-filter=ACM | grep ".php\{0,1\}$")

if [[ "$STAGED_FILES" = "" ]]; then
  exit 0
fi

PASS=true

echo -e "\nValidating PHPCS:\n"

# Check for phpcs
which ./vendor/bin/phpcs &> /dev/null
if [[ "$?" == 1 ]]; then
  echo -e "\t\033[41mPlease install PHPCS\033[0m"
  exit 1
fi

RULESET=./phpcs.xml

for FILE in $STAGED_FILES
do
  ./vendor/bin/phpcs --standard="$RULESET" "$FILE"

  if [[ "$?" == 0 ]]; then
    echo -e "\t\033[32mPHPCS Passed: $FILE\033[0m"
  else
    echo -e "\t\033[41mPHPCS Failed: $FILE\033[0m"
    PASS=false
  fi
done

echo -e "\nPHPCS validation completed!\n"

if ! $PASS; then
  echo -e "\033[41mCOMMIT FAILED:\033[0m Your commit contains files that should pass PHPCS but do not. Please fix the PHPCS errors and try again.\n"
  exit 1
else
  echo -e "\033[42mCOMMIT SUCCEEDED\033[0m\n"
fi

exit $?
